﻿using System;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using Microsoft.Win32.SafeHandles;

namespace XenAdmin.Native
{
	public class NativeCallDummy: INativeCall
    {
		public bool BringWindowToTop(IntPtr window)
        {
            return false;
        }

        public bool CloseWindow(IntPtr window)
        {
            return false;
        }

        public IntPtr CreateIconIndirect(ref ICONINFO iconinfo)
        {
			return new IntPtr(0);
        }

        public bool DestroyIcon(IntPtr hIcon)
        {
            return false;
        }

        public IntPtr SendMessage(IntPtr hWnd, uint Msg, uint wParam, string lParam)
        {
			return new IntPtr(0);
        }

        public bool GetComboBoxInfo(IntPtr hwnd, ref COMBOBOXINFO pcbi)
        {
            return false;
        }

        public bool SetForegroundWindow(IntPtr window)
        {
            return false;
        }

        public bool OpenIcon(IntPtr window)
        {
            return false;
        }

        public IntPtr FindWindowEx(IntPtr parent, IntPtr childAfter, string className, string windowName)
        {
			return new IntPtr(0);
        }

        public IntPtr FindWindowWin32(string className, string windowName)
        {
			return new IntPtr(0);
        }

        public int SendMessage(IntPtr window, int message, int wparam, int lparam)
        {
            return 0;
        }

        public int PostMessage(IntPtr window, int message, int wparam, int lparam)
        {
            return 0;
        }

        public IntPtr GetParent(IntPtr window)
        {
			return new IntPtr(0);
        }

        public IntPtr GetDesktopWindow()
        {
			return new IntPtr(0);
        }

        public IntPtr GetForegroundWindow()
        {
			return new IntPtr(0);
        }

        public IntPtr GetLastActivePopup(IntPtr window)
        {
			return new IntPtr(0);
        }

        public int GetWindowText(IntPtr window, ref StringBuilder text, int copyCount)
        {
			if (text == null)
			    text = new StringBuilder();
			return 0;
        }

        public bool SetWindowText(IntPtr window, string text)
        {
            return false;
        }

        public int GetWindowTextLength(IntPtr window)
        {
            return 0;
        }

        public int SetWindowLong(IntPtr window, int index, int value)
        {
            return 0;
        }

		public IntPtr GetWindowLong(IntPtr window, int index)
        {
			return new IntPtr(0);
        }

        public int GetClassName(IntPtr window, ref StringBuilder text, int copyCount)
        {
			if (text == null)
			    text = new StringBuilder();
            return 0;
        }

        public bool EnumChildWindows(IntPtr window, EnumWindowsProc callback, int i)
        {
            return false;
        }

        public bool EnumThreadWindows(int threadId, EnumWindowsProc callback, int i)
        {
            return false;
        }

        public bool EnumWindows(EnumWindowsProc callback, int i)
        {
            return false;
        }

        public int GetWindowThreadProcessId(IntPtr window, ref int processId)
        {
			return 0;
        }

        public int GetWindowThreadProcessId(IntPtr window, IntPtr ptr)
        {
            return 0;
        }

        public bool IsChild(IntPtr parent, IntPtr window)
        {
            return false;
        }

        public bool IsIconic(IntPtr window)
        {
            return false;
        }

        public bool IsZoomed(IntPtr window)
        {
            return false;
        }

        public IntPtr GetWindowDC(IntPtr hwnd)
        {
			return new IntPtr(0);
        }

        public int ReleaseDC(IntPtr hwnd, IntPtr dc)
        {
            return 0;
        }

        public bool MoveWindow(IntPtr hwnd, int X, int Y, int width, int height, bool repaint)
        {
            return false;
        }

        public IntPtr GetNextWindow(IntPtr hwnd, int wFlag)
        {
			return new IntPtr(0);
        }

        public IntPtr GetWindow(IntPtr hWnd, uint uCmd)
        {
			return new IntPtr(0);
        }

        public bool PeekMessage(out NativeMessage message, IntPtr handle, uint filterMin, uint filterMax, uint removeMsg)
        {
			message = new NativeMessage();
            return false;
        }

        public IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, ref POINT pt)
        {
			return new IntPtr(0);
        }

        public IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, IntPtr lParam)
        {
			return new IntPtr(0);
        }

        public IntPtr GetDCEx(IntPtr hWnd, IntPtr hrgnClip, int flags)
        {
			return new IntPtr(0);
        }

        public int GetGuiResources(IntPtr hProcess, int uiFlags)
        {
            return 0;
        }

        public int ToUnicode(uint wVirtKey, uint wScanCode, IntPtr lpKeyState, out StringBuilder pwszBuff, int cchBuff, uint wFlags)
        {
			pwszBuff = new StringBuilder();
            return 0;
        }

        public bool GetKeyboardState(IntPtr lpKeyState)
        {
            return false;
        }

        public Int32 FlashWindowEx(ref FLASHWINFO pwfi)
        {
			return 0;
        }

        public IntPtr GetClipboardViewer()
        {
			return new IntPtr(0);
        }

        public IntPtr SetClipboardViewer(IntPtr hWnd)
        {
			return new IntPtr(0);
        }

        public bool ChangeClipboardChain(IntPtr hWnd, IntPtr hWndNext)
        {
            return false;
        }

        public IntPtr GetDlgItem(IntPtr hDlg, int nIDDlgItem)
        {
			return new IntPtr(0);
        }

        public IntPtr CreateWindowEx(uint dwExStyle, string lpClassName, string lpWindowName, uint dwStyle, int x, int y, int nWidth, int nHeight, IntPtr hWndParent, IntPtr hMenu, IntPtr hInstance, IntPtr lpParam)
        {
			return new IntPtr(0);
        }

        public bool SetWindowPos(IntPtr hWnd, IntPtr hWndInsertAfter, int X, int Y, int cx, int cy, uint uFlags)
        {
            return false;
        }

		public bool ScreenToClient(IntPtr hWnd, ref POINT lpPoint)
        {
            return false;
        }

        public bool GetWindowRect(IntPtr hWnd, ref RECT lpRect)
        {
            return false;
        }

        public bool SetWindowText(int hWnd, string lpString)
        {
            return false;
        }

        public bool DestroyWindow(IntPtr hwnd)
        {
            return false;
        }

        public IntPtr SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, string lParam)
        {
			return new IntPtr(0);
        }

        public IntPtr SetFocus(IntPtr hwnd)
        {
			return new IntPtr(0);
        }

        public bool GetScrollInfo(IntPtr hWnd, int n, ref ScrollInfo lpScrollInfo)
        {
            return false;
        }

        public int SetScrollInfo(IntPtr hwnd, int fnBar, ref ScrollInfo lpsi, bool fRedraw)
        {
            return 0;
        }

        public IntPtr FindWindow(string lpClassName, string lpWindowName)
        {
			return new IntPtr(0);
        }

        public bool PostMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam)
        {
            return false;
        }

        public int SetWindowLong(IntPtr hWnd, int nIndex, IntPtr newWndProc)
        {
            return 0;
        }

        public IntPtr CallWindowProc(IntPtr lpPrevWndFunc, IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam)
        {
			return new IntPtr(0);
        }

        public bool GetClientRect(IntPtr hWnd, out RECT lpRect)
        {
			lpRect = new RECT();
            return false;
        }

        public IntPtr SetWindowsHookEx(int idHook, LowLevelKeyboardProc lpfn, IntPtr hMod, uint dwThreadId)
        {
			return new IntPtr(0);
        }

        public bool UnhookWindowsHookEx(IntPtr hhk)
        {
            return false;
        }

        public int CallNextHookEx(IntPtr hhk, int nCode, int wParam, ref KBDLLHOOKSTRUCT lParam)
        {
            return 0;
        }

        public bool QueryPerformanceCounter(out long x)
        {
			x = 0;
            return false;
        }

        public bool QueryPerformanceFrequency(out long x)
        {
			x = 0;
            return false;
        }

        public bool Process32First(ToolHelpHandle hSnapshot, ref PROCESSENTRY32 lppe)
        {
            return false;
        }

        public bool Process32Next(ToolHelpHandle hSnapshot, ref PROCESSENTRY32 lppe)
        {
            return false;
        }

        public uint FormatMessage(uint dwFlags, IntPtr lpSource, uint dwMessageId, uint dwLanguageId, ref IntPtr lpBuffer, uint nSize, IntPtr pArguments)
        {
            return 0;
        }

        public IntPtr LocalFree(IntPtr hMem)
        {
			return new IntPtr(0);
        }

        public bool EnumUILanguages(EnumUILanguagesProc pUILanguageEnumProc, uint dwFlags, IntPtr lParam)
        {
            return false;
        }

        public bool GetDiskFreeSpaceEx(string lpszPath, ref long lpFreeBytesAvailable, ref long lpTotalNumberOfBytes, ref long lpTotalNumberOfFreeBytes)
        {
            return false;
        }

        public int GetCurrentThreadId()
        {
            return 0;
        }

		public IntPtr CreateNamedPipe(String pipeName, uint openMode, uint pipeMode, uint maxInstances, uint outputBufferSize, uint inputBufferSize, uint timeoutInterval, IntPtr pipeSecurityDescriptor)
        {
			return new IntPtr(0);
        }

        public bool ConnectNamedPipe(IntPtr namedPipeHandle, ref NativeOverlapped overlapped)
        {
            return false;
        }

        public bool DisconnectNamedPipe(IntPtr hHandle)
        {
            return false;
        }

        public bool ReadFile(IntPtr fileHandle, ref byte[] dataBuffer, uint nNumberOfBytesToRead, out uint lpNumberOfBytesRead, ref NativeOverlapped overlapped)
        {
			dataBuffer = new byte[0];
			lpNumberOfBytesRead = 0;
            return false;
        }

		public bool WriteFile(IntPtr fileHandle, ref byte[] dataBuffer, uint nNumberOfBytesToWrite, out uint lpNumberOfBytesWritten, ref NativeOverlapped overlapped)
        {
			dataBuffer = new byte[0];
			lpNumberOfBytesWritten = 0;
            return false;
        }

		public bool PeekNamedPipe(IntPtr handle, ref byte[] buffer, uint nBufferSize, out uint bytesRead, out uint bytesAvail, out uint BytesLeftThisMessage)
        {
			buffer = new byte[0];
			bytesRead = 0;
			bytesAvail = 0;
			BytesLeftThisMessage = 0;
            return false;
        }

		public bool CallNamedPipe(string lpNamedPipeName, byte[] lpInBuffer, uint nInBufferSize, ref byte[] lpOutBuffer, uint nOutBufferSize, out uint lpBytesRead, uint nTimeOut)
        {
			lpOutBuffer = new byte[0];
			lpBytesRead = 0;
            return false;
        }

        public bool CloseHandle(IntPtr hObject)
        {
            return false;
        }

        public void SetLastError(uint dwErrCode)
        {
        }

        public IntPtr GetModuleHandle(string lpModuleName)
        {
			return new IntPtr(0);
        }

        public bool FlushFileBuffers(SafeFileHandle hFile)
        {
            return false;
        }

		public ToolHelpHandle CreateToolhelp32Snapshot(SnapshotFlags dwFlags, uint th32ProcessID)
		{
			return new ToolHelpHandle();
		}


        public IntPtr CreateCompatibleDC(IntPtr hdc)
        {
			return new IntPtr(0);
        }

        public bool DeleteDC(IntPtr hdc)
        {
            return false;
        }

        public IntPtr SelectObject(IntPtr hdc, IntPtr hgdiobj)
        {
			return new IntPtr(0);
        }

        public bool DeleteObject(IntPtr hObject)
        {
            return false;
        }

        public bool BitBlt(IntPtr hObject, int nXDest, int nYDest, int nWidth, int nHeight, IntPtr hObjSource, int nXSrc, int nYSrc, int dwRop)
        {
            return false;
        }

        public IntPtr CreateRoundRectRgn(int nLeftRect, int nTopRect, int nRightRect, int nBottomRect, int nWidthEllipse, int nHeightEllipse)
        {
			return new IntPtr(0);
        }

        public int SelectClipRgn(IntPtr hdc, IntPtr hrgn)
        {
            return 0;
        }

        public int IsAppThemed()
        {
            return 0;
        }

        public long DeleteUrlCacheEntry(string url)
        {
            return 0;
        }

        public bool OpenProcessToken(IntPtr ProcessHandle, TOKEN_ACCESS DesiredAccess, out IntPtr TokenHandle)
        {
			TokenHandle = new IntPtr();
            return false;
        }

		public uint GetModuleFileNameEx(IntPtr hProcess, IntPtr hModule, out StringBuilder lpBaseName, ref int nSize)
		{
			lpBaseName = new StringBuilder();
			return 0;
		}

        public bool GetSaveFileName(ref OPENFILENAME lpofn)
        {
            return false;
        }

        public int CommDlgExtendedError()
        {
            return 0;
        }

    }
}
