public static extern bool BitBlt(IntPtr hObject, int nXDest, int nYDest, int nWidth, int nHeight, IntPtr hObjSource, int nXSrc, int nYSrc, int dwRop);
public static extern bool BringWindowToTop(IntPtr window);
public static extern bool CallNamedPipe(string lpNamedPipeName, byte[] lpInBuffer, uint nInBufferSize, ref byte[] lpOutBuffer, uint nOutBufferSize, out uint lpBytesRead, uint nTimeOut);
public static extern bool ChangeClipboardChain(IntPtr hWnd, IntPtr hWndNext);
public static extern bool CloseHandle(IntPtr hObject);
public static extern bool CloseWindow(IntPtr window);
public static extern bool ConnectNamedPipe(IntPtr namedPipeHandle, ref NativeOverlapped overlapped);
public static extern bool DeleteDC(IntPtr hdc);
public static extern bool DeleteObject(IntPtr hObject);
public static extern bool DestroyIcon(IntPtr hIcon);
public static extern bool DestroyWindow(IntPtr hwnd);
public static extern bool DisconnectNamedPipe(IntPtr hHandle);
public static extern bool EnumChildWindows(IntPtr window, EnumWindowsProc callback, int i);
public static extern bool EnumThreadWindows(int threadId, EnumWindowsProc callback, int i);
public static extern bool EnumUILanguages(EnumUILanguagesProc pUILanguageEnumProc, uint dwFlags, IntPtr lParam);
public static extern bool EnumWindows(EnumWindowsProc callback, int i);
public static extern bool FlushFileBuffers(SafeFileHandle hFile);
public static extern bool GetClientRect(IntPtr hWnd, out RECT lpRect);
public static extern bool GetComboBoxInfo(IntPtr hwnd, ref COMBOBOXINFO pcbi);
public static extern bool GetDiskFreeSpaceEx(string lpszPath, ref long lpFreeBytesAvailable, ref long lpTotalNumberOfBytes, ref long lpTotalNumberOfFreeBytes);
public static extern bool GetKeyboardState(IntPtr lpKeyState);
public static extern bool GetSaveFileName(ref OPENFILENAME lpofn);
public static extern bool GetScrollInfo(IntPtr hWnd, int n, ref ScrollInfo lpScrollInfo);
public static extern bool GetWindowRect(IntPtr hWnd, ref RECT lpRect);
public static extern bool IsChild(IntPtr parent, IntPtr window);
public static extern bool IsIconic(IntPtr window);
public static extern bool IsZoomed(IntPtr window);
public static extern bool MoveWindow(IntPtr hwnd, int X, int Y, int width, int height, bool repaint);
public static extern bool OpenIcon(IntPtr window);
public static extern bool OpenProcessToken(IntPtr ProcessHandle, TOKEN_ACCESS DesiredAccess, out IntPtr TokenHandle);
public static extern bool PeekMessage(out NativeMessage message, IntPtr handle, uint filterMin, uint filterMax, uint removeMsg);
public static extern bool PeekNamedPipe(IntPtr handle, [Out] byte[] buffer, uint nBufferSize, out uint bytesRead, out uint bytesAvail, out uint BytesLeftThisMessage);
public static extern bool PostMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);
public static extern bool Process32First(ToolHelpHandle hSnapshot, ref PROCESSENTRY32 lppe);
public static extern bool Process32Next(ToolHelpHandle hSnapshot, ref PROCESSENTRY32 lppe);
public static extern bool QueryPerformanceCounter(out long x);
public static extern bool QueryPerformanceFrequency(out long x);
public static extern bool ReadFile(IntPtr fileHandle, [Out] byte[] dataBuffer, uint nNumberOfBytesToRead, out uint lpNumberOfBytesRead, [In] ref NativeOverlapped overlapped);
public static extern bool ScreenToClient(IntPtr hWnd, ref Win32.POINT lpPoint);
public static extern bool SetForegroundWindow(IntPtr window);
public static extern bool SetWindowPos(IntPtr hWnd, IntPtr hWndInsertAfter, int X, int Y, int cx, int cy, uint uFlags);
public static extern bool SetWindowText(int hWnd, string lpString);
public static extern bool SetWindowText(IntPtr window, string text);
public static extern bool UnhookWindowsHookEx(IntPtr hhk);
public static extern bool WriteFile(IntPtr fileHandle, [Out] byte[] dataBuffer, uint nNumberOfBytesToWrite, out uint lpNumberOfBytesWritten, [In] ref NativeOverlapped overlapped);
public static extern Int32 FlashWindowEx(ref FLASHWINFO pwfi);
public static extern int CallNextHookEx(IntPtr hhk, int nCode, int wParam, ref KBDLLHOOKSTRUCT lParam);
public static extern int CommDlgExtendedError();
public static extern int GetClassName(IntPtr window, [In][Out] StringBuilder text, int copyCount);
public static extern int GetCurrentThreadId();
public static extern int GetGuiResources(IntPtr hProcess, int uiFlags);
public static extern int GetWindowLong(IntPtr window, int index);
public static extern int GetWindowText(IntPtr window, [In][Out] StringBuilder text, int copyCount);
public static extern int GetWindowTextLength(IntPtr window);
public static extern int GetWindowThreadProcessId(IntPtr window, IntPtr ptr);
public static extern int GetWindowThreadProcessId(IntPtr window, ref int processId);
public static extern int IsAppThemed();
public static extern int PostMessage(IntPtr window, int message, int wparam, int lparam);
public static extern IntPtr CallWindowProc(IntPtr lpPrevWndFunc, IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);
public static extern IntPtr CreateCompatibleDC(IntPtr hdc);
public static extern IntPtr CreateIconIndirect(ref ICONINFO iconinfo);
public static extern IntPtr CreateNamedPipe(String pipeName, uint openMode, uint pipeMode, uint maxInstances, uint outputBufferSize, uint inputBufferSize, uint timeoutInterval, IntPtr pipeSecurityDescriptor);
public static extern IntPtr CreateRoundRectRgn(int nLeftRect, int nTopRect, int nRightRect, int nBottomRect, int nWidthEllipse, int nHeightEllipse);
public static extern IntPtr CreateWindowEx(uint dwExStyle, string lpClassName, string lpWindowName, uint dwStyle, int x, int y, int nWidth, int nHeight, IntPtr hWndParent, IntPtr hMenu, IntPtr hInstance, IntPtr lpParam);
public static extern IntPtr FindWindowEx(IntPtr parent, IntPtr childAfter, string className, string windowName);
public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);
public static extern IntPtr FindWindowWin32(string className, string windowName);
public static extern IntPtr GetClipboardViewer();
public static extern IntPtr GetDCEx(IntPtr hWnd, IntPtr hrgnClip, int flags);
public static extern IntPtr GetDesktopWindow();
public static extern IntPtr GetDlgItem(IntPtr hDlg, int nIDDlgItem);
public static extern IntPtr GetForegroundWindow();
public static extern IntPtr GetLastActivePopup(IntPtr window);
public static extern IntPtr GetModuleHandle(string lpModuleName);
public static extern IntPtr GetNextWindow(IntPtr hwnd, [MarshalAs(UnmanagedType.U4)] int wFlag);
public static extern IntPtr GetParent(IntPtr window);
public static extern IntPtr GetWindowDC(IntPtr hwnd);
public static extern IntPtr GetWindow(IntPtr hWnd, uint uCmd);
public static extern IntPtr GetWindowLong(IntPtr hWnd, int nIndex);
public static extern IntPtr LocalFree(IntPtr hMem);
public static extern IntPtr SelectObject(IntPtr hdc, IntPtr hgdiobj);
public static extern IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, IntPtr lParam);
public static extern IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, ref POINT pt);
public static extern IntPtr SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, string lParam);
public static extern IntPtr SendMessage(IntPtr hWnd, uint Msg, uint wParam, [MarshalAs(UnmanagedType.LPWStr)] string lParam);
public static extern IntPtr SetClipboardViewer(IntPtr hWnd);
public static extern IntPtr SetFocus(IntPtr hwnd);
public static extern IntPtr SetWindowsHookEx(int idHook, LowLevelKeyboardProc lpfn, IntPtr hMod, uint dwThreadId);
public static extern int ReleaseDC(IntPtr hwnd, IntPtr dc);
public static extern int SelectClipRgn(IntPtr hdc, IntPtr hrgn);
public static extern int SendMessage(IntPtr window, int message, int wparam, int lparam);
public static extern int SetScrollInfo(IntPtr hwnd, int fnBar, [In] ref ScrollInfo lpsi, bool fRedraw);
public static extern int SetWindowLong(IntPtr hWnd, int nIndex, IntPtr newWndProc);
public static extern int SetWindowLong(IntPtr window, int index, int value);
public static extern int ToUnicode(uint wVirtKey, uint wScanCode, IntPtr lpKeyState, [Out, MarshalAs(UnmanagedType.LPWStr, SizeConst = TO_UNICODE_BUFFER_SIZE)] StringBuilder pwszBuff, int cchBuff, uint wFlags);
public static extern long DeleteUrlCacheEntry(string url);
public static extern ToolHelpHandle CreateToolhelp32Snapshot(SnapshotFlags dwFlags, uint th32ProcessID);
public static extern uint FormatMessage(uint dwFlags, IntPtr lpSource, uint dwMessageId, uint dwLanguageId, ref IntPtr lpBuffer, uint nSize, IntPtr pArguments);
public static extern uint GetModuleFileNameEx(IntPtr hProcess, IntPtr hModule, ref StringBuilder lpBaseName, ref [MarshalAs(UnmanagedType.U4)] int nSize);
public static extern void SetLastError(uint dwErrCode);
